(in-package :usocket)

(defun socket-connect/udp (host port &key (stream nil) (element-type '(unsigned-byte 8))
			                  local-host local-port)
  (if (and host port)
      (let ((socket (extensions:connect-to-inet-socket (host-to-hbo host) port :datagram)))
	(if stream
	    (make-stream-datagram-socket socket
					 (system:make-fd-stream socket
								:input t :output t
								:buffering :full
								:element-type element-type))
	    (make-datagram-socket socket)))
      (make-datagram-socket (extensions:create-inet-socket :datagram))))

(defmethod socket-send ((socket datagram-usocket) buffer length &key address port)
  (let ((s (socket socket))
        (host (if (stringp address)
                  (car (extensions:host-entry-addr-list
                        (extensions:lookup-host-entry address)))
                address)))
    (extensions:inet-sendto s buffer length host port)))

(defmethod socket-receive ((socket datagram-usocket) buffer length)
  (let ((s (socket socket)))
    (let ((real-buffer (or buffer
                           (make-array length :element-type '(unsigned-byte 8))))
          (real-length (or length
                           (length buffer))))
      (if (plusp (extensions:inet-recvfrom s real-buffer real-length))
          (values real-buffer real-length)
        (error "CMUCL: socket-receive failed")))))
