;;;; -*- Mode: lisp; Syntax: ansi-common-lisp; Base: 10; Package: usocket; -*-

#|
<DOCUMENTATION>
 <DESCRIPTION>
  UDP support patch for USOCKET project. This file should sync with usocket-svn at

    svn://common-lisp.net/project/usocket/svn/usocket/trunk

  Waiting for USOCKET author to merge us.

  I'm good at hacking package of others.
  </DESCRIPTION>
 <COPYRIGHT YEAR='2007-2008' AUTHOR='Chun Tian (binghe)' MARK='(C)'
            HREF='https://cl-net-snmp.svn.sourceforge.net/svnroot/cl-net-snmp/snmp/trunk/usocket-udp/usocket.lisp'/>
 <CHRONOLOGY>
  <DELTA DATE='20080317'>create USOCKET UDP patch file "patch-usocket.lisp"</DELTA>
  </CHRONOLOGY>
 </DOCUMENTATION>
|#

(in-package :usocket)

(export '(stream-datagram-usocket
          socket-connect/udp
          socket-send
          socket-receive))

(defclass stream-datagram-usocket (stream-usocket datagram-usocket)
  ()
  (:documentation "connected datagram-usocket with a lisp stream interface"))

(defun stream-datagram-usocket-p (socket)
  (typep socket 'stream-datagram-usocket))

(defun make-stream-datagram-socket (socket stream)
  (unless socket
    (error 'invalid-socket-error))
  (unless stream
    (error 'invalid-socket-stream-error))
  (make-instance 'stream-datagram-usocket
                 :socket socket
                 :stream stream
                 :connected-p t))

#-(or clisp armedbear)
(progn
  (defun host-to-vector-quad (host)
    "Translate a host specification (vector quad, dotted quad or domain name)
to a vector quad."
    (etypecase host
      (string (let* ((ip (ignore-errors
                           (dotted-quad-to-vector-quad host))))
                (if (and ip (= 4 (length ip)))
                    ;; valid IP dotted quad?
                    ip
                  (get-random-host-by-name host))))
      ((vector t 4) host)
      ((simple-array (unsigned-byte 8) (4)) host)
      (integer (hbo-to-vector-quad host))
      (null nil)))

  (defun host-to-hbo (host)
    (etypecase host
      (string (let ((ip (ignore-errors
                          (dotted-quad-to-vector-quad host))))
                (if (and ip (= 4 (length ip)))
                    (host-byte-order ip)
                  (host-to-hbo (get-host-by-name host)))))
      ((vector t 4) (host-byte-order host))
      ((simple-array (unsigned-byte 8) (4)) (host-byte-order host))
      (integer host)
      (null nil))))
